package org;

import java.net.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import org.util.xml.io.*;
import org.util.xml.element.*;
import org.server.*;
import org.*;

public class TeamManager {

	private ArrayList<TeamManagerListener> listener_list_ = new ArrayList<TeamManagerListener>();
	private ArrayList<RealPlayer> real_player_list_ = new ArrayList<RealPlayer>();
	private ArrayList<BufferedWriter> log_writer_list_ = new ArrayList<BufferedWriter>();

	public TeamManager(XMLConfigManager config) throws Exception {
		init(config);
	}

	private XMLConfigManager config_;
	private DatagramPacket packet_;
	private DatagramSocket socket_;
	private byte[] receive_buf_;

	public void init(XMLConfigManager config) throws Exception {

		config_ = config;

		if(config_.getBoolean("dummyserver/launch", true)) {
			new Thread(new Runnable(){public void run(){try{
				DummyServer server = new DummyServer(config_);
				server.start();
			}catch(Exception e){e.printStackTrace();}}}).start();
		}

		TagElement[] player_info_list = config_.getTag("player_list").getTagChildren("player");
		
		for(int i=0;i<player_info_list.length;i++) {
			final TagElement player_info = player_info_list[i];
			new Thread(new Runnable(){public void run(){try{
//				Thread.sleep(1000);
//				alert("start sample");
				String ip = config_.getValue("server/ip", "localhost");
				int port = config_.getInt("server/port", 3130);
				int timeout = config_.getInt("server/timeout", 1000);
				RealPlayer rp = new RealPlayer(ip, port, timeout, player_info);
				
				addPlayer(rp);
			}catch(Exception e){e.printStackTrace();}}}).start();
		}


		
//		tryToConnect();
	}


	public void addTeamManagerListener(TeamManagerListener listener) {
		for(int i=0;i<real_player_list_.size();i++) {
			listener.addPlayer(real_player_list_.get(i));
		}
		listener_list_.add(listener);
System.out.println("add listener");
	}
	public void removeTeamManagerListener(TeamManagerListener listener) {
		listener_list_.remove(listener);
	}
	public void addPlayer(RealPlayer real) {
		real_player_list_.add(real);
		fireAddedPlayer(real);
	}
	
	private void fireAddedPlayer(RealPlayer real) {
System.out.println("fire added player");
		alert("connection detected: "+real.getID());
		for(int i=0;i<listener_list_.size();i++) {
			listener_list_.get(i).addPlayer(real);
		}
	}
	public void fireConnected(RealPlayer real, VirtualPlayer virtual) {
		for(int i=0;i<listener_list_.size();i++)
			listener_list_.get(i).connected(real, virtual);
	}
	public void disconnected(RealPlayer real, VirtualPlayer virtual) {
		for(int i=0;i<listener_list_.size();i++)
			listener_list_.get(i).disconnected(real, virtual);
	}

/*
	protected void fireChanges(Object source) {
		ChangeEvent e = new ChangeEvent(source);
		for(int i=0;i<listener_list_.size();i++)
			listener_list_.get(i).stateChanged(e);
	}
*/
	public void addLogWriter(Writer log_writer) {
		log_writer_list_.add(new BufferedWriter(log_writer));
	}
	public void removeLogWriter(Writer log_writer) {
		log_writer_list_.remove(new BufferedWriter(log_writer));
	}
	public void alert(Object message) {
		for(int i=0;i<log_writer_list_.size();i++) {
			try{
				BufferedWriter bw = log_writer_list_.get(i);
				bw.write(message.toString());
				bw.newLine();
				bw.flush();
			} catch(Exception e) { e.printStackTrace(); }
		}
//		javax.swing.JOptionPane.showMessageDialog(null, message);
	}
}
