package org;

import java.net.*;
import java.io.*;
import org.util.xml.io.*;
import org.util.xml.element.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.*;

public class TeamManagerGUI {

	public TeamManagerGUI(TeamManager manager, XMLConfigManager config) throws Exception {
		init(manager, config);
	}

	private TeamManager manager_;
	private XMLConfigManager config_;

	public void init(TeamManager manager, XMLConfigManager config) throws Exception {

		manager_ = manager;
		config_ = config;
		
		createAndShowGUI();
	}
	
	public void createAndShowGUI() {
		JFrame frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setContentPane(createContent());
		//frame.pack();
		frame.setSize(500, 500);
		frame.setLocationRelativeTo(null);
		frame.setVisible(true);
	}
	
	public JComponent createContent() {
		JPanel contentpane = new JPanel(new BorderLayout());
		contentpane.add(new JLabel("TeamManager"), BorderLayout.NORTH);
		final JPanel player_map_panel = new JPanel();
		player_map_panel.setLayout(new BoxLayout(player_map_panel, BoxLayout.Y_AXIS));
		manager_.addTeamManagerListener(new TeamManagerListener(){
			public void addPlayer(RealPlayer real) {
				player_map_panel.add(new RealPlayerGUI(real));
				player_map_panel.revalidate();
			}
			public void connected(RealPlayer real, VirtualPlayer virtual) {
			}
			public void disconnected(RealPlayer real, VirtualPlayer virtual) {
			}
		});
		JPanel tmppane = new JPanel(new BorderLayout());
		tmppane.add(player_map_panel, BorderLayout.NORTH);
		contentpane.add(new JScrollPane(tmppane), BorderLayout.CENTER);
		final JTextArea log = new JTextArea();
		manager_.addLogWriter(new Writer() {
			@Override
			public void close() {}
			@Override
			public void flush() {}
			@Override
			public void write(char[] cbuf, int off, int len) {
				log.append(new String(cbuf, off, len));
			}
		});
		JScrollPane sp = new JScrollPane(log);
		sp.setPreferredSize(new Dimension(100, 100));
		contentpane.add(sp, BorderLayout.SOUTH);
		contentpane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		return contentpane;
	}

	public static void alert(Object message) {
//		javax.swing.JOptionPane.showMessageDialog(null, message);
	}

}
