package org.agent;

import org.util.xml.io.*;
import org.util.xml.element.*;
import org.*;
import org.util.*;

import javax.swing.*;

public class SampleAgent {

	protected FieldPanel view;
	protected WorldData w;
	private TagElement message = null;
	private RealPlayer player;

	public SampleAgent(RealPlayer p) throws Exception {
		player = p;
		view = new FieldPanel();
		JFrame frame = new JFrame(player.getNickName());
		frame.setContentPane(view);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
		
		w = new WorldData();

//////////////////////////////////////////////////
////This will be removed!!!////////////////
//	player.receiveTag();////////////////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
	}

	/**
	 * Accessible Object
	 *    w : WorldData
	 *    ex. w.ball(), w. 
	 * view : FieldPanel
	 * 
	 * 
	 */
	public void plan(WorldData w, FieldPanel view) throws Exception {
		Vector me = w.me();
		Vector ball = w.ball();
		Vector goal = w.bottomRightGoal();

		if(ball.dis() < 100) {
			view.drawString("kick!", ball);
			kick(goal, 1);
		} else {
			view.drawLine(me, ball);
			view.drawString("go to ball", ball);
			int right = 0;
			int left = 0;
			if(ball.rad() > deg2rad(30)) {
				right = 0;
				left = 50;
			} else if(ball.deg() < deg2rad(-30)) {
				right = 50;
				left = 0;
			} else {
				right = 50;	
				left = 50;
			}
			velocities(right, left);
		}
	}
	
/*
long start = System.currentTimeMillis();
long end = System.currentTimeMillis();
System.out.println("plan: "+(end-start));
*/

	public void start() throws Exception {
		for(int counter=0; true; counter++) {
			
			TagElement tag = null;
			try{
alert("receiving: "+counter);
				long start = System.currentTimeMillis();
				tag = player.receiveTag();
				long end = System.currentTimeMillis();
alert("received: "+(end-start)+"[ms]");
				w.update(tag);
				view.update(w);
				plan(w, view);
			} catch(Exception e) {
				e.printStackTrace();
				if(tag!=null)
					System.err.println(tag.toString());
			}
			try{
				if(message==null) velocities(0, 0);
alert("sending");
				player.send(message);
alert("send: "+message);
			}catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public void kick(Vector angle, int force) throws Exception {
		message=player.createKickMessage(angle.deg(), force);
	}
	public void kick(Vector angle_force) throws Exception {
		message=player.createKickMessage(angle_force.deg(), (int)angle_force.dis());
	}
	public void velocities(double right, double left) throws Exception {
		message=player.createVerocitiesMessage(right, left);
	}
	
	public static double rad2deg(double rad) {
		return rad*180/Math.PI;
	}
	public static double deg2rad(double deg) {
		return deg*Math.PI/180;
	}
	public static void main(String[] args) throws Exception {

		if(args.length==1 && args[0].endsWith("help")) {
			System.out.println("java SampleAgent [IP]");
			System.out.println("java SampleAgent [IP PORT]");
			System.out.println("java SampleAgent [IP PORT NICKNAME RCID VTID]");
			System.exit(1);
		}

		String ip = "localhost";
		int port = 3310;
		int timeout = 0; 
		String nickname = "sample player";
		int rcid = 0;
		int vtid = 0;

		if(args.length>0) ip = args[0];
		if(args.length>1) port = Integer.parseInt(args[1]);
		if(args.length==5) {
			nickname = args[2];
			rcid = Integer.parseInt(args[3]);
			vtid = Integer.parseInt(args[4]);
		}
		
		System.out.println("ip: "+ip);
		System.out.println("port: "+port);
		System.out.println("timeout: "+timeout);
		System.out.println("nickname: "+nickname);
		System.out.println("rcid: "+rcid);
		System.out.println("vtid: "+vtid);
		
		
		RealPlayer player = new RealPlayer(ip, port, timeout, nickname, rcid, vtid);
		
		SampleAgent agent = new SampleAgent(player);
		agent.start();
	}

	public static void alert(Object message) {
		System.out.println(message);
	}
}

/*
<WorldData>
   <time>5.25131</time>
   <agent_id>0</agent_id>
   <nickname>player1</nickname>
   <status>found</status>
   <max_agent>2</max_agent>
   <playMode>play on</playMode>
   <score>
      <yellow>0</yellow>
      <blue>0</blue>
   </score>
   <wheel_velocities>
      <right>0</right>
      <left>0</left>
   </wheel_velocities>
   <ball>
      <dist>117</dist>
      <angle>39</angle>
   </ball>
   <teamMate>
      <id>1</id>
      <nickname>player2</nickname>
      <status>found</status>
      <dist>89</dist>
      <angle>48</angle>
      <orientation>107</orientation>
   </teamMate>
   <opponent>
      <id>5</id>
      <nickname>player7</nickname>
      <status>found</status>
      <dist>167</dist>
      <angle>46</angle>
      <orientation>161</orientation>
   </opponent>
   <flag>
      <id>top_left_pole</id>
      <dist>152</dist>
      <angle>-59</angle>
   </flag>
   <flag>
      <id>bottom_left_pole</id>
      <dist>116</dist>
      <angle>-83</angle>
   </flag>
   <flag>
      <id>top_right_pole</id>
      <dist>310</dist>
      <angle>57</angle>
   </flag>
   <flag>
      <id>bottom_right_pole</id>
      <dist>294</dist>
      <angle>69</angle>
   </flag>
   <flag>
      <id>top_left_corner</id>
      <dist>236</dist>
      <angle>-40</angle>
   </flag>
   <flag>
      <id>bottom_left_corner</id>
      <dist>126</dist>
      <angle>-133</angle>
   </flag>
   <flag>
      <id>top_right_corner</id>
      <dist>359</dist>
      <angle>41</angle>
   </flag>
   <flag>
      <id>bottom_right_corner</id>
      <dist>298</dist>
      <angle>89</angle>
   </flag>
   <flag>
      <id>top_left_goal</id>
      <dist>148</dist>
      <angle>-8</angle>
   </flag>
   <flag>
      <id>bottom_left_goal</id>
      <dist>14</dist>
      <angle>85</angle>
   </flag>
   <flag>
      <id>top_right_goal</id>
      <dist>224</dist>
      <angle>36</angle>
   </flag>
   <flag>
      <id>bottom_right_goal</id>
      <dist>169</dist>
      <angle>78</angle>
   </flag>
   <flag>
      <id>top_left_small_area</id>
      <dist>83</dist>
      <angle>-74</angle>
   </flag>
   <flag>
      <id>bottom_left_small_area</id>
      <dist>128</dist>
      <angle>-48</angle>
   </flag>
   <flag>
      <id>top_right_small_area</id>
      <dist>259</dist>
      <angle>68</angle>
   </flag>
   <flag>
      <id>bottom_right_small_area</id>
      <dist>277</dist>
      <angle>55</angle>
   </flag>
   <flag>
      <id>middle_center</id>
      <dist>117</dist>
      <angle>39</angle>
   </flag>
   <flag>
      <id>top_center</id>
      <dist>229</dist>
      <angle>11</angle>
   </flag>
   <flag>
      <id>bottom_center</id>
      <dist>112</dist>
      <angle>112</angle>
   </flag>
</WorldData>
*/
