package org.protocol;

import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class UDPServerSocket {

	private DatagramPacket packet_;
	private DatagramSocket socket_;
	private int port_;
	private int timeout_;
	private int buf_size_;
	private ArrayList<SimpleUDPServerConnection> connection_list_
							 = new ArrayList<SimpleUDPServerConnection>();
	volatile private boolean stop_ = false;

	public UDPServerSocket(int port, int timeout, int buf_size) throws Exception {
		port_ = port;
		timeout_ = timeout;
		buf_size_ = buf_size;
		init();
	}

	private void init() throws Exception {
		byte[] buf_ = new byte[buf_size_];
		packet_ = new DatagramPacket(buf_, buf_.length);
		socket_ = new DatagramSocket(port_);
	}

	public void start() throws Exception {
		alert("now waiting...");

		long total = 0;
		int counter=0;
		while(!stop_&&counter++<999) {
			long start = System.currentTimeMillis();
			socket_.receive(packet_); // <block>
//			alert(address);
			receivePacket(packet_);
			long end = System.currentTimeMillis();
			if(counter>0)
			total += (end-start);
		}
		System.out.println("counter: "+counter);
		System.out.println("total time: "+total);
		System.out.println("average time: "+total/998);
	}

	public void receivePacket(DatagramPacket packet) throws Exception {
		InetSocketAddress address = (InetSocketAddress)packet.getSocketAddress();
		for(int i=0; i<connection_list_.size(); i++)
			if(address.equals(connection_list_.get(i).getRemoteAddress())) {
				connection_list_.get(i).received(packet);
				return ;
			}
		SimpleUDPServerConnection connection = new SimpleUDPServerConnection(packet);
		connection_list_.add(connection);
	}
	
	private Connection createConnection(final InetSocketAddress address) {
		return new Connection() {
			public InetSocketAddress getRemoteAddress() {
				return address;
			}
			public void send(String message) throws Exception {
				alert(message);
			}
			public String receive() throws Exception {
				return null;
			}
		};
	}

	public static void main(String[] args) throws Exception {
		UDPServerSocket server = new UDPServerSocket(3310, 0, 1024);
		server.start();
//		alert(connection);
	}

	public static void alert(Object message) {
		System.out.println(message);
	}
}
