package org.realobject;

import java.awt.geom.*;
import java.net.*;
import org.util.xml.io.*;
import org.util.xml.element.*;

public class RCRSVirtualSoccerEcoBe extends VirtualEcoBe {

	private Point2D.Double location_;
	private InetSocketAddress remote_address_;
	private long last_received_time_ = -1;
	private long timeout_length_ = 1000;
	private DatagramPacket packet_;
	private String team_name_;
	private String command_type_;
	private double[] command_args_;
	private long command_time_;
	
	public	 RCRSVirtualSoccerEcoBe(int id) {
		super(id);
	}
	
	public InetSocketAddress getRemoteAddress() {
		return remote_address_;
	}

	public void setTeamName(String team_name) {
		team_name_ = team_name;
	}
	public String getTeamName() {
		return team_name_;
	}

	public void setClient(InetSocketAddress remote_address) throws Exception {
System.out.println("set client: "+remote_address);
//if(remote_address_ != null) throw new Exception("this ecobe is already connected: "+remote_address);
if(remote_address_ != null) System.out.println("chenged new connection: "+remote_address);
		last_received_time_ = System.currentTimeMillis();
		packet_ = new DatagramPacket(new byte[0], 0, remote_address);
		remote_address_ = remote_address;
	}
	
	public boolean isConnected() {
		if(last_received_time_ == -1) return false;
		long now = System.currentTimeMillis();
		return (now-last_received_time_)<timeout_length_;
	}

	public void update(DatagramPacket packet) {
//System.out.println("update");
		last_received_time_ = System.currentTimeMillis();
		remote_address_ = (InetSocketAddress)packet.getSocketAddress();
//		System.out.println("now parse packet");
		String message = new String(packet.getData(), packet.getOffset(), packet.getLength());
		TagElement tag = null;
		try{
			tag = XMLIO.read(new StringBuffer(message));
			if(tag.getKey().equals("connect")) return;
			TagElement command = tag.getTagChildren()[0];
			if(command.getKey().equals("kick")) {
				setCommand("kick", getDouble(command, "angle"), getDouble(command, "force"));
			} else if(command.getKey().equals("wheel_velocities")){
				setCommand("wheel_velocities", getDouble(command, "left"), getDouble(command, "right"));
			}
		}catch(Exception e){
			e.printStackTrace();
			System.err.println("cannot parse: "+tag);
		}
	}
	public String getCommandType() {
		return command_type_;
	}
	public double[] getCommandArgs() {
		return command_args_;
	}
	public void setCommand(String type, double... args) {
		command_time_ = System.currentTimeMillis();
		command_type_ = type;
		command_args_ = args;
	}
	public double getDouble(TagElement tag, String key) {
		return Double.parseDouble(tag.getChildValue(key));
	}
	public String createPacket() {
		return null;
	}
	public DatagramPacket createPacket(String message) {
		byte[] send_buf = message.getBytes();
		packet_.setData(send_buf);
		return packet_;
	}
}
