package org.server;

import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;

import org.realobject.*;

public class SoccerField extends JPanel {

	
	private DummyServer server_;
	private double zoom_ = 1;
	private double offset_x_ = 5;
	private double offset_y_ = 5;
	private Object target_ = null;
	private BasicStroke stroke_0 = new BasicStroke((float)0);
	private BasicStroke stroke_3 = new BasicStroke((float)3);
	
	public SoccerField(DummyServer server) {
		server_ = server;
	}

	public void update() {
//		System.out.println("update method is called");
		repaint();
	}

	public void createAndShowGUI() {
		addMouseListener(new MouseAdapter(){
			public void mousePressed(MouseEvent e) {
				double x = (e.getX()-offset_x_)/zoom_;
				double y = (e.getY()-offset_y_)/zoom_;
				ArrayList<RCRSVirtualSoccerEcoBe> ecobe_list = server_.getEcoBeList();
				for(int i=0; i<ecobe_list.size(); i++) {
					EcoBe ecobe = ecobe_list.get(i);
					Point2D loc = ecobe.getLocation();
					if(Math.sqrt((loc.getX()-x)*(loc.getX()-x) + (loc.getY()-y)*(loc.getY()-y)) < ecobe.getRadius())
						target_ = ecobe;
				}
				if(target_==null) {
					Point2D ball = server_.getBallLocation();
					if(Math.sqrt((ball.getX()-x)*(ball.getX()-x) + (ball.getY()-y)*(ball.getY()-y)) < server_.getBallRadius()/zoom_)
						target_ = ball;
				}
			}
			public void mouseReleased(MouseEvent e) {
				target_ = null;
			}
		});
		addMouseMotionListener(new MouseMotionListener(){
			int last_x;
			int last_y;
			public void mouseMoved(MouseEvent e) {
				last_x = e.getX();
				last_y = e.getY();
				ArrayList<RCRSVirtualSoccerEcoBe> ecobe_list = server_.getEcoBeList();
			}
			public void mouseDragged(MouseEvent e) {
				int x = e.getX();
				int y = e.getY();
//System.out.println("target: " + target_);
				if(target_ != null) {
					if(target_ instanceof EcoBe)
						((EcoBe)target_).move((x-last_x)/zoom_, (y-last_y)/zoom_);
					else if(target_ instanceof Point2D) {
						Point2D p = ((Point2D)target_);
						p.setLocation(p.getX()+(x-last_x)/zoom_, p.getY()+(y-last_y)/zoom_);
					} else {
						System.out.println("unknown target type.");
					}
					repaint();
				}
				last_x = x;
				last_y = y;
			}
		});
		addMouseWheelListener(new MouseWheelListener(){
			public void mouseWheelMoved(MouseWheelEvent e) {
				double x = (e.getX()-offset_x_)/zoom_;
				double y = (e.getY()-offset_y_)/zoom_;
				ArrayList<RCRSVirtualSoccerEcoBe> ecobe_list = server_.getEcoBeList();
				for(int i=0; i<ecobe_list.size(); i++) {
					RCRSVirtualSoccerEcoBe ecobe = ecobe_list.get(i);
					Point2D loc = ecobe.getLocation();
					if(Math.sqrt((loc.getX()-x)*(loc.getX()-x) + (loc.getY()-y)*(loc.getY()-y)) < ecobe.getRadius()/zoom_) {
						double d = (e.getWheelRotation()==1 ? 0.1 : -0.1);
						ecobe.rotate(d);
					}
				}
			}
		});		JFrame frame = new JFrame("Dummy Server");
		frame.setContentPane(this);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(500, 400);
		frame.setVisible(true);
	}
	
	public void paint(Graphics g) {
		double margin = 5;
		Rectangle2D area = server_.getArea();
		double rw = area.getWidth();
		double rh = area.getHeight();
		double rx = area.getX();
		double ry = area.getY();
		double w = getWidth();
		double h = getHeight();
		double wzoom = (w-2*margin)/(rw);
		double hzoom = (h-2*margin)/(rh);
		zoom_ = Math.min(wzoom, hzoom);
		offset_x_ = (w-rw*zoom_)/2+rx;
		offset_y_ = (h-rh*zoom_)/2+ry;
		
		Graphics2D g2 = (Graphics2D)g;
		g2.setColor(Color.green);
		g2.fill(new Rectangle2D.Double(0, 0, w, h));
		g2.setColor(Color.white);
		g2.setStroke(new BasicStroke((float)3));
		try{ // try to write field border
			HashMap<String, Point2D.Double> flags = server_.getFlags();
			Point2D.Double a = flags.get("top_left_corner");
			Point2D.Double b = flags.get("top_right_corner");
			Point2D.Double c = flags.get("bottom_right_corner");
			Point2D.Double d = flags.get("bottom_left_corner");
			drawPath(g2, w, h, a, b, c, d);
		}catch(Exception e) {
			e.printStackTrace();
		}
		try{
			HashMap<String, Point2D.Double> flags = server_.getFlags();
			Point2D.Double a = flags.get("top_left_pole");
			Point2D.Double b = flags.get("bottom_left_small_area");
			Point2D.Double c = flags.get("top_left_small_area");
			Point2D.Double d = flags.get("bottom_left_pole");
			drawPath(g2, w, h, a, b, c, d);
		}catch(Exception e) {
			e.printStackTrace();
		}
		try{
			HashMap<String, Point2D.Double> flags = server_.getFlags();
			Point2D.Double a = flags.get("top_right_pole");
			Point2D.Double b = flags.get("bottom_right_small_area");
			Point2D.Double c = flags.get("top_right_small_area");
			Point2D.Double d = flags.get("bottom_right_pole");
			drawPath(g2, w, h, a, b, c, d);
		}catch(Exception e) {
			e.printStackTrace();
		}
		try{
			HashMap<String, Point2D.Double> flags = server_.getFlags();
			Point2D.Double a = flags.get("top_center");
			Point2D.Double b = flags.get("middle_center");
			Point2D.Double c = flags.get("bottom_center");
			drawPath(g2, w, h, a, b, c);
		}catch(Exception e) {
			e.printStackTrace();
		}
/*
		ArrayList<RCRSVirtualSoccerEcoBe> ecobe_list = server_.getEcoBeList();
		for(int i=0;i<ecobe_list.size(); i++) {
			EcoBe ecobe = ecobe_list.get(i);
			double x = tx(ecobe.getLocation().getX());
			double y = ty(ecobe.getLocation().getY());
			double r = ecobe.getRadius();
			double dx = r*1.2*Math.cos(ecobe.getAngle());
			double dy = r*1.2*Math.sin(ecobe.getAngle());
			g2.setColor(Color.blue);
			g2.fill(new Arc2D.Double(x-r, y-r, r+r, r+r, 0, 360, Arc2D.OPEN));
			g2.setColor(Color.black);
			g2.draw(new Line2D.Double(x, y, x+dx, y+dy));
		}
*/
		ArrayList<RCRSVirtualSoccerEcoBe> blue_list = server_.getBlueTeamMemberList();
		ArrayList<RCRSVirtualSoccerEcoBe> yellow_list = server_.getYellowTeamMemberList();
		for(int i=0;i<blue_list.size(); i++) {
			RCRSVirtualSoccerEcoBe ecobe = blue_list.get(i);
			drawAgent(g2, ecobe, Color.blue);
		}
		for(int i=0;i<yellow_list.size(); i++) {
			RCRSVirtualSoccerEcoBe ecobe = yellow_list.get(i);
			drawAgent(g2, ecobe, Color.yellow);
		}

		try{
			Point2D.Double ball = server_.getBallLocation();
			double x = tx(ball.getX());
			double y = ty(ball.getY());
			double r = server_.getBallRadius()*zoom_;
			g2.setColor(Color.black);
			g2.fill(new Arc2D.Double(x-r, y-r, r+r, r+r, 0, 360, Arc2D.OPEN));
		}catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public double tx(double x) {
		return zoom_*x+offset_x_;
	}
	public double ty(double y) {
		return zoom_*y+offset_y_;
	}
	
	public void drawAgent(Graphics2D g2, RCRSVirtualSoccerEcoBe ecobe, Color agent_color) {
		double x = tx(ecobe.getLocation().getX());
		double y = ty(ecobe.getLocation().getY());
		double r = ecobe.getRadius()*zoom_;
		double dx = r*1.2*Math.cos(ecobe.getAngle());
		double dy = r*1.2*Math.sin(ecobe.getAngle());
		Arc2D circle_shape = new Arc2D.Double(x-r, y-r, r+r, r+r, 0, 360, Arc2D.OPEN);
		if(ecobe.isConnected()) {
			g2.setColor(agent_color);
			g2.fill(circle_shape);
		}
		g2.setColor(Color.black);
		g2.setStroke(stroke_0);
		g2.draw(circle_shape);
		g2.setStroke(stroke_3);
		g2.draw(new Line2D.Double(x, y, x+dx, y+dy));
	}
	
	public void drawPath(Graphics2D g2, double w, double h, Point2D.Double... points) {

		double x1 = zoom_*points[points.length-1].getX() + offset_x_;
		double y1 = zoom_*points[points.length-1].getY() + offset_y_;
		for(int i=0;i<points.length;i++) {
			double x2 = zoom_*points[i].getX()+offset_x_;
			double y2 = zoom_*points[i].getY()+offset_y_;
			g2.draw(new Line2D.Double(x1, y1, x2, y2));
			x1=x2; y1=y2;
		}
	}
	
	public static void alert(Object message) {
		System.out.println(message);
		// javax.swing.JOptionPane.showMessageDialog(null, message);
	}
}
