package org.util;

import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class Vector {

	private double angle_rad_;
	private double distance_;

	/**
	 * 
	 */
	public Vector(double angle_rad, double distance) {
		raddis(angle_rad, distance);
	}

	public Vector(int angle_degree, double distance) {
		degdis(angle_degree, distance);
	}

	private void raddis(double angle_rad, double distance) {
		rad(angle_rad);
		dis(distance);
	}
	private void degdis(int angle_deg, double distance) {
		deg(angle_deg);
		dis(distance);
	}
	
	public double deg() {
		return rad2deg(angle_rad_);
	}
	public void deg(double angle_deg) {
		rad(deg2rad(angle_deg));
	}
	public double rad() {
		return angle_rad_;
	}
	public void rad(double angle) {
		angle_rad_ = roundRad(angle);
	}
	public double dis() {
		return distance_;
	}
	public void dis(double distance) {
		distance_ = distance;
	}
	
	public Vector add(Vector vector) {
		double x = calcX() + vector.calcX();
		double y = calcY() + vector.calcY();
		return new Vector(Math.atan2(y, x), Math.sqrt(x*x+y*y));
	}
	public Vector sub(Vector vector) {
		double x = calcX() - vector.calcX();
		double y = calcY() - vector.calcY();
		return new Vector(Math.atan2(y, x), Math.sqrt(x*x+y*y));
	}
	public Vector multi(double scalar) {
		return new Vector((double)angle_rad_, scalar*distance_);
	}
	public double multi(Vector vector) {
		return distance_*vector.rad()*Math.cos(angle_rad_ - vector.rad());
	}
	public Vector normalize() {
		return new Vector((double)angle_rad_, 1.0);
	}
	public Vector normalize(double distance) {
		return new Vector((double)angle_rad_, distance);
	}
/*
	public double calcDistanceFrom(Vector v) {
	}
*/
	public double calcX() {
		return distance_ * Math.cos(angle_rad_);
	}
	public double calcY() {
		return distance_ * Math.sin(angle_rad_);
	}
	public static double deg2rad(double deg) {
		return deg*Math.PI/180;
	}
	public static double rad2deg(double rad) {
		return rad*180/Math.PI;
	}
	public static double roundRad(double rad) {
		while(rad>Math.PI) rad -= 2*Math.PI;
		while(rad<-Math.PI) rad += 2*Math.PI;
		return rad;
	}
}
