/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.util.xml.io;

import org.util.xml.parse.policy.*;
import org.util.xml.parse.*;
import org.util.xml.element.*;
import java.net.*;
import java.io.*;

/**
 *
 * @author masaru
 */
public class XMLIO {

	public static TagElement read(StringBuffer xml_text) throws Exception {
		ElementParser parser = new ElementParser(new StringReader(xml_text.toString()));
		parser.setPolicy(new XMLParserPolicy());
		parser.parse();
		return parser.getFirstPlainTagElement();
	}
	public static TagElement read(URL url) throws Exception {
		ElementParser parser = new ElementParser(url.openStream());
		parser.setPolicy(new XMLParserPolicy());
		parser.parse();
		return parser.getFirstPlainTagElement();
	}
	public static TagElement read(URL url, String encoding) throws Exception {
		ElementParser parser = new ElementParser(url.openStream(), encoding);
		parser.setPolicy(new XMLParserPolicy());
		parser.parse();
		return parser.getFirstPlainTagElement();
	}
	public static TagElement read(String file_name_or_url) throws Exception {
		return read(findURL(file_name_or_url));
	}
	public static TagElement read(String file_name_or_url, String encoding) throws Exception {
		return read(new URL(file_name_or_url), encoding);
	}
	public static TagElement read(File file) throws Exception {
		return read(file.toURI().toURL());
	}
	public static TagElement read(File file, String encoding) throws Exception {
		return read(file.toURI().toURL(), encoding);
	}

	protected static URL findURL(String name) throws Exception {
		File file = new File(name);
		if(file.exists())
			return file.toURI().toURL();
		URL url = ClassLoader.getSystemResource(name);
		if(url != null)
			return url;
		throw new Exception("cannot find resource: "+name);
	}


	public static void write(File file, Element element) throws Exception {
		write(new FileWriter(file), element);
	}
	public static void write(Writer writer, Element element) throws Exception {
		element.write(writer);
	}
}
